    /////////////////////////////////////////////////////////////////
   //         Pixy Arduino Example              v1.00             //
  //       Get the latest version of the code here:              //
 //     http://educ8s.tv/pixy-2-machine-vision-module           //
/////////////////////////////////////////////////////////////////

#include <Pixy2.h>  // Get it here: https://github.com/charmedlabs/pixy2/raw/master/releases/arduino/arduino_pixy2-1.0.3.zip

Pixy2 pixy;

int GREEN_LED1 = 2;
int GREEN_LED2 = 3;
int RED_LED = 4;
int YELLOW_LED = 5;

int numberOfGreenPikachus = 0;
int numberOfRedPikachus = 0;
int numberOfLighters = 0;

void setup()
{
  pinMode(GREEN_LED1, OUTPUT);
  pinMode(GREEN_LED2, OUTPUT);
  pinMode(RED_LED, OUTPUT); 
  pinMode(YELLOW_LED, OUTPUT); 

  Serial.begin(115200);
  Serial.print("Starting...\n");
  
  pixy.init();
}

void loop()
{ 
  int i; 
  // grab blocks!
  pixy.ccc.getBlocks();
  
  // If there are detect blocks, print them!
  if (pixy.ccc.numBlocks)
  {
    Serial.print("Detected ");
    Serial.println(pixy.ccc.numBlocks);
    for (i=0; i<pixy.ccc.numBlocks; i++)
    {
      if(pixy.ccc.blocks[i].m_signature ==1)
      {
         numberOfGreenPikachus ++;
      }
      if(pixy.ccc.blocks[i].m_signature ==2)
      {
         numberOfRedPikachus ++;
      }
      if(pixy.ccc.blocks[i].m_signature ==3)
      {
         numberOfLighters ++;
      }
    }

    if(numberOfGreenPikachus == 1)
    {
      turnOnOneGreenLED();
    }else if(numberOfGreenPikachus == 2)
    {
       turnOnTwoGreenLEDS();
    }else
    {
      turnOffGreenLEDS();
    }

     if(numberOfRedPikachus == 1)
    {
      turnOnRedLED();
    }else
    {
      turnOffRedLED();
    }

    if(numberOfLighters == 1)
    {
      turnOnYellowLED();
    }else
    {
      turnOffYellowLED();
    }
    Serial.print("Green Pikachus: ");
    Serial.println(numberOfGreenPikachus);
    Serial.print("Red Pikachus: ");
    Serial.println(numberOfRedPikachus);
    Serial.print("Lighters: ");
    Serial.println(numberOfLighters);
  } 
  else //Nothing detected, turn LEDs off
  {
     turnOffAllLEDs();
  }
     numberOfGreenPikachus = 0;
     numberOfRedPikachus = 0;
     numberOfLighters = 0;
}

void turnOffAllLEDs()
{
   digitalWrite(GREEN_LED1, LOW);
   digitalWrite(GREEN_LED2, LOW);
   digitalWrite(RED_LED, LOW);
   digitalWrite(YELLOW_LED, LOW);
}

void turnOnOneGreenLED()
{
  digitalWrite(GREEN_LED1, HIGH);
  digitalWrite(GREEN_LED2, LOW);
  delay(10);
}

void turnOnTwoGreenLEDS()
{
  digitalWrite(GREEN_LED1, HIGH);
  digitalWrite(GREEN_LED2, HIGH);
  delay(10);
}

void turnOffGreenLEDS()
{
 digitalWrite(GREEN_LED1, LOW);
 digitalWrite(GREEN_LED2, LOW);
}
  

void turnOffRedLED()
{
 digitalWrite(RED_LED, LOW);
}
void turnOnRedLED()
{
  digitalWrite(RED_LED, HIGH);
  delay(10);
}

void turnOffYellowLED()
{
 digitalWrite(YELLOW_LED, LOW);
}
void turnOnYellowLED()
{
  digitalWrite(YELLOW_LED, HIGH);
  delay(10);
}
